
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "font_effect_blur_color_capi.h"

/* standard var */
static int done = 0;
extern int win_w, win_h;
/* private data */
static evas::text *text;
static const int MAX_BLUR = 100;

/* setup */
static void _setup(void)
{
   evas::canvas canvas(::eo_ref(G_evas));
   int w, h;

   evas::text *o = new evas::text(efl::eo::parent = canvas);
   o->evas::object::color_set(0, 0, 0, 255);
   o->font_set("Vera-Bold", 80);
   o->text_set("Font Effect");
   o->visibility_set(true);
   o->evas::object::size_get(&w, &h);
   o->evas::object::position_set((win_w / 2) - (w / 2) - MAX_BLUR, (win_h / 2) - (h / 2) - MAX_BLUR);
   text = o;
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   text->visibility_set(false);
   delete text;
}

/* loop - do things */
static void _loop(double t, int f)
{
   if (text)
     {
        char buf[256];
        const char *str = "buffer:a(rgba);padding_set(%d);blend(dst=a,color=darkblue);blur(%d,src=a);";
        sprintf(buf, str, MAX_BLUR, ((f % MAX_BLUR) + 1));
        text->filter_program_set(buf);
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
