
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "image_blend_occlude1_capi.h"

/* standard var */
static int done = 0;
/* private data */
static efl::eina::list<evas::image> images;

/* setup */
static void _setup(void)
{
   evas::canvas canvas(::eo_ref(G_evas));
   srnd();
   for (int i = 0; i < OBNUM; i++)
     {
        evas::image o(efl::eo::parent = canvas);
        images.push_back(o);
        if (i < (OBNUM / 2))
          {
             eo_do(o._eo_ptr(), efl_file_set(build_path("logo.png"), NULL)); // XXX
          }
        else
          {
             Evas_Coord x, y;

             x = (win_w / 4) + (((rnd() & 0xff) * ((win_w / 2) - 120)) >> 8);
             y = (win_h / 4) + (((rnd() & 0xff) * ((win_h / 2) - 120)) >> 8);
             eo_do(o._eo_ptr(), efl_file_set(build_path("image.png"), NULL)); // XXX
             o.evas::object::position_set(x, y);
          }
        o.fill_set(0, 0, 120, 160);
        o.evas::object::size_set(120, 160);
        o.visibility_set(true);
     }
   done = 0;
}

/* cleanup */
static void _cleanup()
{
   for (evas::image& i : images)
     i.parent_set(efl::eo::base(nullptr));
   images.clear();
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i = 0;
   for (evas::image& img : images)
     {
        if (i < (OBNUM / 2))
          {
             Evas_Coord w = 120;
             Evas_Coord h = 160;
             Evas_Coord x = (win_w / 2) - (w / 2);
             x += sin((double)(f + (i * 13)) / (36.7 * SLOW)) * (w / 2);
             Evas_Coord y = (win_h / 2) - (h / 2);
             y += cos((double)(f + (i * 28)) / (43.8 * SLOW)) * (h / 2);
             img.evas::object::position_set(x, y);
          }
        ++i;
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
