
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "image_crossfade_capi.h"

/* standard var */
static int done = 0;

/* private data */
static efl::eina::list<evas::image> images;

/* setup */
static void _setup(void)
{
   evas::canvas canvas(::eo_ref(G_evas));

   evas::image o1(efl::eo::parent = canvas);
   images.push_back(o1);
   eo_do(o1._eo_ptr(), efl_file_set(build_path("im1.png"), NULL)); // XXX
   o1.fill_set(0, 0, 720, 420);
   o1.evas::object::size_set(720, 420);
   o1.visibility_set(true);

   evas::image o2(efl::eo::parent = canvas);
   images.push_back(o2);
   eo_do(o2._eo_ptr(), efl_file_set(build_path("im2.png"), NULL)); // XXX
   o2.fill_set(0, 0, 720, 420);
   o2.evas::object::size_set(720, 420);
   o2.visibility_set(true);

   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   for (evas::image& i : images)
     i.parent_set(efl::eo::base(nullptr));
   images.clear();
}

/* loop - do things */
static void _loop(double t, int f)
{
   if (!images.empty())
     {
        int a = f & 0x1f;
        a = ((a << 3) | (a >> 2)) & 0xff;
        evas::image img = images.back();
        img.evas::object::color_set(a, a, a, a);
   }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
