
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "image_data_ycbcr601pl_map_nearest_solid_rotate_capi.h"

/* standard var */
static int done = 0;

/* private data */
static efl::eina::list<evas::image> images;
static unsigned char *yp = NULL, *up = NULL, *vp = NULL;

/* setup */
static void _setup(void)
{
   evas::canvas canvas(::eo_ref(G_evas));
   for (int i = 0; i < 1; i++)
     {
        evas::image o(efl::eo::parent = canvas);
        images.push_back(o);
        o.content_hint_set(EVAS_IMAGE_CONTENT_HINT_DYNAMIC);
        o.colorspace_set(EVAS_COLORSPACE_YCBCR422P601_PL);
        o.size_set(640, 480);
        o.alpha_set(0);
        o.fill_set(0, 0, 640, 480);
        o.evas::object::size_set(640, 480);
        o.smooth_scale_set(0);
        o.visibility_set(true);
        yp = new unsigned char[640 * 480];
        up = new unsigned char[320 * 240];
        vp = new unsigned char[320 * 240];
        FILE *f = fopen(build_path("tp.yuv"), "rb");
        if (f)
          {
             fread(yp, 640 * 480, 1, f);
             fread(up, 320 * 240, 1, f);
             fread(vp, 320 * 240, 1, f);
             fclose(f);
          }
        unsigned char **data = static_cast<unsigned char**>(o.data_get(1));
        unsigned char **lp = data;
        for (int y = 0; y < 480; y++)
          {
             *lp = yp + (y * 640);
             lp++;
          }
        for (int y = 0; y < 240; y++)
          {
             *lp = up + (y * 320);
             lp++;
          }
        for (int y = 0; y < 240; y++)
          {
             *lp = vp + (y * 320);
             lp++;
          }
        o.data_set(data);
     }
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   for (evas::image& i : images)
     i.parent_set(efl::eo::base(nullptr));
   images.clear();

   delete yp;
   delete up;
   delete vp;
}

/* loop - do things */
static void _loop(double t, int f)
{
   static Evas_Map *m = NULL;
   if (!m) m = evas_map_new(4);
   evas_map_smooth_set(m, 0);
   for (evas::image& img : images)
     {
        Evas_Coord w = 640;
	Evas_Coord h = 480;
	Evas_Coord x = (win_w / 2) - (w / 2);
	Evas_Coord y = (win_h / 2) - (h / 2);
	evas_map_util_points_populate_from_geometry(m, x, y, w, h, 0);
        evas_map_util_rotate(m, f, x + (w / 2), y + (h / 2));
        img.map_enable_set(1);
        img.map_set(m);
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
