
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "image_quality_scale_capi.h"

/* standard var */
static int done = 0;

/* private data */
static efl::eina::list<evas::image> images;

/* setup */
static void _setup(void)
{
   evas::canvas canvas(::eo_ref(G_evas));
   for (int i = 0; i < 1; i++)
     {
        evas::image o(efl::eo::parent = canvas);
        images.push_back(o);
        eo_do(o._eo_ptr(), efl_file_set(build_path("tp.png"), NULL)); // XXX
        o.fill_set(0, 0, 640, 480);
        o.evas::object::size_set(640, 480);
        o.visibility_set(true);
     }
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   for (evas::image& i : images)
     i.parent_set(efl::eo::base(nullptr));
   images.clear();
}

/* loop - do things */
static void _loop(double t, int f)
{
   for (evas::image& img : images)
     {
        Evas_Coord w = 640;
	Evas_Coord h = 480;
	w *= (f / 100.0) * 4.0;
	h *= (f / 100.0) * 4.0;
	Evas_Coord x = (win_w / 2) - (w / 2);
	Evas_Coord y = (win_h / 2) - (h / 2);
        img.evas::object::position_set(x, y);
        img.evas::object::size_set(w, h);
        img.fill_set(0, 0, w, h);
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
