
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "proxy_text_random_capi.h"

/* standard var */
static int done = 0;

/* private data */
static efl::eina::list<evas::object> texts;

/* setup */
static void _setup(void)
{
   int i = 0;
   evas::canvas canvas(::eo_ref(G_evas));
   Evas_Coord x, y, w, h;
   char buf[1024];
   const char *strs[] = {
      "Big", "Smelly", "Fish", "Pants", "Octopus", "Garden", "There", "I",
	"Am", "You", "Are", "Erogenous", "We", "Stick", "Wet", "Fishy",
	"Fiddly", "Family", "Lair", "Monkeys", "Magazine"
   };
   srnd();
   evas::text o(efl::eo::parent = canvas);
   texts.push_back(o);
   snprintf(buf, sizeof(buf), "%s %s %s %s.",
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))]);

   o.font_set("Vera-Bold", 20);
   o.text_set(buf);
   o.evas::object::color_set(0, 0, 0, 255);
   o.evas::object::size_get(&w, &h);
   x = (win_w / 2) - (w / 2);
   x += ::sin((double)((i * 13)) / (36.7 * SLOW)) * (w / 2);
   y = (win_h / 2) - (h / 2);
   y += ::cos((double)((i * 28)) / (43.8 * SLOW)) * (w / 2);
   o.evas::object::position_set(x, y);
   o.evas::object::visibility_set(true);
   for (i = 1; i < OBNUM ; i ++)
     {
        evas::image o2(efl::eo::parent = canvas);
        texts.push_back(o2);
        o2.source_set(texts.front());
        texts.front().evas::object::size_get(&w, &h);
        o2.evas::object::size_set(w, h);
        o2.fill_set(0, 0, w, h);
	x = (win_w / 2) - (w / 2);
	x += sin((double)((i * 13)) / (36.7 * SLOW)) * (w / 2);
	y = (win_h / 2) - (h / 2);
	y += cos((double)((i * 28)) / (43.8 * SLOW)) * (w / 2);
        o2.evas::object::position_set(x, y);
        o2.evas::object::visibility_set(true);
     }

   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   for (evas::object& obj : texts)
     {
        obj.visibility_set(false); // XXX
        obj.parent_set(efl::eo::base(nullptr));
     }
   texts.clear();
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i,w,h;
   char buf[1024];
   const char *strs[] = {
      "Big", "Smelly", "Fish", "Pants", "Octopus", "Garden", "There", "I",
      "Am", "You", "Are", "Erogenous", "We", "Stick", "Wet", "Fishy",
      "Fiddly", "Family", "Lair", "Monkeys", "Magazine"
   };
   snprintf(buf, sizeof(buf), "%s %s %s %s.",
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))]);
   efl::eina::list<evas::object>::iterator
     it = texts.begin(),
     end = texts.end();
   if (it != end)
     {
        efl::eo::downcast<evas::text>(*it).text_set(buf);
        (*it++).evas::object::size_get(&w, &h);
     }
   for (; it != end; ++it)
     {
        (*it).evas::object::size_set(w, h);
        efl::eo::downcast<evas::image>(*it).fill_set(0, 0, w, h);
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
