
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "text_basic_capi.h"

/* standard var */
static int done = 0;

/* private data */
static efl::eina::list<evas::text> texts;

/* setup */
static void _setup(void)
{
   evas::canvas canvas(::eo_ref(G_evas));
   for (int i = 0; i < OBNUM; i++)
     {
        evas::text o(efl::eo::parent = canvas);
        texts.push_back(o);
        o.font_set("Vera-Bold", 20);
        o.text_set("This is a test string");
        o.evas::object::color_set(0, 0, 0, 255);
        o.evas::object::visibility_set(true);
     }
   done = 0;
}


/* cleanup */
static void _cleanup(void)
{
   for (evas::text& t : texts)
     t.parent_set(efl::eo::base(nullptr));
   texts.clear();
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i = 0;
   for (evas::text& text : texts)
     {
        Evas_Coord w = 0, h = 0;
        text.size_get(&w, &h);
        Evas_Coord x = (win_w / 2) - (w / 2);
        x += sin((double)(f + (i * 13)) / (36.7 * SLOW)) * (w / 2);
        Evas_Coord y = (win_h / 2) - (h / 2);
        y += cos((double)(f + (i * 28)) / (43.8 * SLOW)) * (w / 2);
        text.evas::object::position_set(x, y);
        ++i;
     }
   FPS_STD(NAME);
}


static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
