
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "Eo.h"
#include "Evas.h"

#include "Eo.hh"
#include "Eina.hh"
#include "Evas.hh"

#include "main.h"

#define EXPEDITE_CXX_TEST_IMPL
#include "textblock_auto_align_capi.h"

/* standard var */
static int done = 0;

/* private data */
static evas::textblock *text_block;

/* setup */
static void _setup(void)
{
   evas::canvas canvas(::eo_ref(G_evas));
   text_block = new evas::textblock(efl::eo::parent = canvas);
   Evas_Textblock_Style *st = ::evas_textblock_style_new();
   ::evas_textblock_style_set
     (st,
      "DEFAULT='font=Sans font_size=10 color=#000000 wrap=word'"
      );
   text_block->style_set(st);
   text_block->clear();
   text_block->text_markup_set(
      "This is a test of auto alignment in Evas<ps/>"
      "<br/>"
      "This text should be left aligned<ps/>"
      "\xE2\x80\x8FThis text should be right aligned<ps/>"
      "\xE2\x80\x8FThis text should be right aligned<br/>"
      "Same as this text.<ps/>"
      "This text should be left aligned<br/>"
      "\xE2\x80\x8FSame as this text."
      "<br/><br/><ps/>"
      "The word 'זה' should be the rightmost, 'טקסט' after, and 'בעברית' last<br/>"
      "in the following text:<ps/>"
      "זה טקסט בעברית<ps/>"
      "<br/>"
      "In the next text, the paragraph should be right aligned and the<br/>"
      "words should appear in the following order: 'דוגמה' first, 'of' second,<br/>"
      "‎'טקסט' third, 'english' fourth and 'in' fifth, counting from right to left<ps/>"
      "דוגמה of טקסט in english."
      );
   text_block->visibility_set(true);
   ::evas_textblock_style_free(st);
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   text_block->parent_set(efl::eo::base(nullptr));
   delete text_block;
}

/* loop - do things */
static void _loop(double t, int f)
{
   if (text_block)
     {
        Evas_Coord x, y, w, h, w0, h0;
        int i = 0;
        text_block->size_native_get(&w0, &h0);
        w = w0;
        h = h0;
        w += fabs(sin((double)(f + (i * 13)) / (31.1 * SLOW))) * (w0);
        x = (win_w / 2) - (w / 2);
        y = (win_h / 2) - (h0 / 2);
        text_block->evas::object::position_set(x, y);
        text_block->evas::object::size_set(w, h);
   }
   FPS_STD(NAME);
}

static void _key(char *key)
{
   KEY_STD;
}

extern "C" void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}

