#undef FNAME
#undef NAME
#undef ICON

/* metadata */
#define FNAME image_data_argb_alpha_start
#define NAME "Image Data ARGB Alpha"
#define ICON "data.png"

#ifndef PROTO
# ifndef UI
#  include "main.h"

/* standard var */
static int done = 0;

/* private data */
static Evas_Object *o_images[1];

/* setup */
static void _setup(void)
{
   int i;
   Evas_Object *o;
   for (i = 0; i < 1; i++)
     {
        o = eo_add(EVAS_IMAGE_CLASS, G_evas);
        o_images[i] = o;
        eo_do(o,
              evas_obj_image_content_hint_set(EVAS_IMAGE_CONTENT_HINT_DYNAMIC),
              evas_obj_image_colorspace_set(EVAS_COLORSPACE_ARGB8888),
              evas_obj_image_size_set(640, 480),
              evas_obj_image_alpha_set(1),
              evas_obj_image_fill_set(0, 0, 640, 480),
              evas_obj_size_set(640, 480),
              evas_obj_visibility_set(EINA_TRUE));
     }
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   int i;
   for (i = 0; i < 1; i++) eo_del(o_images[i]);
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i, st;
   Evas_Coord x, y, w, h;
   for (i = 0; i < 1; i++)
     {
        unsigned int *data, *p;
        int a, r, g, b;
        w = 640;
        h = 480;
        x = (win_w / 2) - (w / 2);
        y = (win_h / 2) - (h / 2);
        eo_do(o_images[i],
              evas_obj_position_set(x, y),
              evas_obj_size_set(w, h),
              evas_obj_image_fill_set(0, 0, w, h),
              data = evas_obj_image_data_get(1),
              st = evas_obj_image_stride_get());
        st = st >> 2;
        p = data;
        for (y = 0; y < h; y++)
          {
             for (x = 0; x < w; x++)
               {
                  r = (x * y / 7) + f;
                  g = (x / 2);
                  b = (y / 2);
                  a = (x + y);
                  r &= 0xff;
                  g &= 0xff;
                  b &= 0xff;
                  a &= 0xff;
                  r = (a * r) / 255;
                  g = (a * g) / 255;
                  b = (a * b) / 255;
                  *p = (a << 24) | (r << 16) | (g << 8) | b;
                  p++;
               }
             p += (st - w);
          }
        eo_do(o_images[i],
              evas_obj_image_data_set(data),
              evas_obj_image_data_update_add( 0, 0, w, h));
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}












/* template stuff - ignore */
# endif
#endif

#ifdef UI
_ui_menu_item_add(ICON, NAME, FNAME);
#endif

#ifdef PROTO
void FNAME(void);
#endif

#ifndef PROTO
# ifndef UI
void FNAME(void)
{
   _setup();
   ui_func_set(_key, _loop);
}
# endif
#endif
#undef FNAME
#undef NAME
#undef ICON
