#undef FNAME
#undef NAME
#undef ICON

/* metadata */
#define FNAME proxy_text_fixed
#define NAME "Proxy Text Fixed"
#define ICON "text.png"

#ifndef PROTO
# ifndef UI
#  include "main.h"

/* standard var */
static int done = 0;

/* private data */
static Evas_Object *o_texts[OBNUM];

/* setup */
static void _setup(void)
{
   int i,w,h;
   Evas_Object *o,*s;
   Evas_Text_Style_Type st;

   st = EVAS_TEXT_STYLE_SHADOW;
   for (i = 0; st <= EVAS_TEXT_STYLE_FAR_SOFT_SHADOW; i++)
     {
	o = eo_add(EVAS_TEXT_CLASS, G_evas);
	o_texts[i] = o;
        eo_do(o,
              efl_text_properties_font_set("Vera-Bold", 20),
              efl_text_set("This is a test string"),
              evas_obj_text_style_set(st),
              evas_obj_color_set(255, 255, 255, 255),
              evas_obj_text_shadow_color_set(0, 0, 0, 24),
              evas_obj_text_glow_color_set(100, 80, 40, 100),
              evas_obj_text_glow2_color_set(50, 10, 5, 50),
              evas_obj_text_outline_color_set(0, 0, 0, 255),
              evas_obj_visibility_set(EINA_TRUE));
	st++;
     }
   st = i;

   for (  ; i < OBNUM ; i ++)
     {
	s = o_texts[i % st];
	o = eo_add(EVAS_IMAGE_CLASS, G_evas);
	o_texts[i] = o;
        eo_do(o, evas_obj_image_source_set(s));
        /* FIXME s == NULL*/
        eo_do(s, evas_obj_size_get(&w, &h));
        eo_do(o,
              evas_obj_size_set(w, h),
              evas_obj_image_fill_set(0, 0, w, h),
              evas_obj_visibility_set(EINA_TRUE));
     }

   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   int i;
   for (i = 0; i < OBNUM; i++) eo_del(o_texts[i]);
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i;
   Evas_Coord x, y, w, h;
   for (i = 0; i < OBNUM; i++)
     {
	eo_do(o_texts[i], evas_obj_size_get(&w, &h));
	x = (win_w / 2) - (w / 2);
	x += sin((double)(f + (i * 13)) / (36.7 * SLOW)) * (w / 2);
	y = (win_h / 2) - (h / 2);
	y += cos((double)(f + (i * 28)) / (43.8 * SLOW)) * (w / 2);
	eo_do(o_texts[i], evas_obj_position_set(x, y));
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}












/* template stuff - ignore */
# endif
#endif

#ifdef UI
_ui_menu_item_add(ICON, NAME, FNAME);
#endif

#ifdef PROTO
void FNAME(void);
#endif

#ifndef PROTO
# ifndef UI
void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
# endif
#endif
#undef FNAME
#undef NAME
#undef ICON
