#undef FNAME
#undef NAME
#undef ICON

/* metadata */
#define FNAME proxy_text_random
#define NAME "Proxy Text Random"
#define ICON "text.png"

#ifndef PROTO
# ifndef UI
#  include "main.h"

/* standard var */
static int done = 0;

/* private data */
static Evas_Object *o_texts[OBNUM];

/* setup */
static void _setup(void)
{
   int i = 0;
   Evas_Object *o;
   Evas_Coord x, y, w, h;
   char buf[1024];
   const char *strs[] = {
      "Big", "Smelly", "Fish", "Pants", "Octopus", "Garden", "There", "I",
	"Am", "You", "Are", "Erogenous", "We", "Stick", "Wet", "Fishy",
	"Fiddly", "Family", "Lair", "Monkeys", "Magazine"
   };
   srnd();
   o = eo_add(EVAS_TEXT_CLASS, G_evas);
   o_texts[0] = o;
   snprintf(buf, sizeof(buf), "%s %s %s %s.",
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))]);

   eo_do(o,
         efl_text_properties_font_set("Vera-Bold", 20),
         efl_text_set(buf),
         evas_obj_color_set(0, 0, 0, 255),
         evas_obj_size_get(&w, &h));
   x = (win_w / 2) - (w / 2);
   x += sin((double)((i * 13)) / (36.7 * SLOW)) * (w / 2);
   y = (win_h / 2) - (h / 2);
   y += cos((double)((i * 28)) / (43.8 * SLOW)) * (w / 2);
   eo_do(o,
         evas_obj_position_set(x, y),
         evas_obj_visibility_set(EINA_TRUE));
   for (i = 1  ; i < OBNUM ; i ++)
     {
	o = eo_add(EVAS_IMAGE_CLASS, G_evas);
	o_texts[i] = o;
	eo_do(o,
              evas_obj_image_source_set(o_texts[0]));
	eo_do(o_texts[0], evas_obj_size_get(&w, &h));
	eo_do(o, evas_obj_size_set(w, h),
	         evas_obj_image_fill_set(0, 0, w, h));
	x = (win_w / 2) - (w / 2);
	x += sin((double)((i * 13)) / (36.7 * SLOW)) * (w / 2);
	y = (win_h / 2) - (h / 2);
	y += cos((double)((i * 28)) / (43.8 * SLOW)) * (w / 2);
	eo_do(o, evas_obj_position_set(x, y),
                 evas_obj_visibility_set(EINA_TRUE));
     }

   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   int i;
   for (i = 0; i < OBNUM; i++) eo_del(o_texts[i]);
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i,w,h;
   char buf[1024];
   const char *strs[] = {
      "Big", "Smelly", "Fish", "Pants", "Octopus", "Garden", "There", "I",
      "Am", "You", "Are", "Erogenous", "We", "Stick", "Wet", "Fishy",
      "Fiddly", "Family", "Lair", "Monkeys", "Magazine"
   };
   snprintf(buf, sizeof(buf), "%s %s %s %s.",
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))],
            strs[rnd() % (sizeof(strs) / sizeof(char *))]);
   eo_do(o_texts[0],
         efl_text_set(buf),
         evas_obj_size_get(&w, &h));
   for (i = 1; i < OBNUM; i++)
     {
        eo_do(o_texts[i],
              evas_obj_size_set(w,h),
              evas_obj_image_fill_set(0,0,w,h));
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}












/* template stuff - ignore */
# endif
#endif

#ifdef UI
_ui_menu_item_add(ICON, NAME, FNAME);
#endif

#ifdef PROTO
void FNAME(void);
#endif

#ifndef PROTO
# ifndef UI
void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
# endif
#endif
#undef FNAME
#undef NAME
#undef ICON
