#undef FNAME
#undef NAME
#undef ICON

/* metadata */
#define FNAME widgets_file_icons_4_start
#define NAME "Widgets File Icons 4"
#define ICON "widgets.png"

#ifndef PROTO
# ifndef UI
#  include "main.h"

/* standard var */
static int done = 0;
/* private data */
#define NUM 512
#define ICON_SIZE 96
static Evas_Object *o_images[NUM];
static Evas_Object *o_texts[NUM];

static const char *icons[] =
{
   "bug.png",
   "bulb.png",
   "camera.png",
   "colorbox.png",

   "e.png",
   "error.png",
   "flower.png",
   "house.png",

   "mushroom.png",
   "pulse.png",
   "typewriter.png",
   "warning.png",

   "watch.png"
};

/* setup */
static void _setup(void)
{
   int i;
   Evas_Object *o;
   for (i = 0; i < NUM; i++)
     {
        o = eo_add(EVAS_IMAGE_CLASS, G_evas);
        o_images[i] = o;
        eo_do(o, efl_file_set(build_path(icons[i % 13]), NULL),
                 evas_obj_image_fill_set(0, 0, ICON_SIZE, ICON_SIZE),
                 evas_obj_size_set(ICON_SIZE, ICON_SIZE),
                 evas_obj_visibility_set(EINA_TRUE));

        o = eo_add(EVAS_TEXT_CLASS, G_evas);
        o_texts[i] = o;
        eo_do(o, efl_text_properties_font_set("Vera-Bold", 10),
                 efl_text_set(icons[i % 13]),
                 evas_obj_color_set(0, 0, 0, 255),
                 evas_obj_visibility_set(EINA_TRUE));
     }
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   int i;
   for (i = 0; i < NUM; i++)
     {
        eo_del(o_images[i]);
        eo_del(o_texts[i]);
     }
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i;
   Evas_Coord x, y, tw, th, cent;
   x = 0;
   y = 0 - f;
   for (i = 0; i < NUM; i++)
     {
        eo_do(o_images[i], evas_obj_position_set(x + 8, y));
        eo_do(o_texts[i], evas_obj_size_get(&tw, &th));
        cent = (ICON_SIZE + 16 - tw) / 2;
        eo_do(o_texts[i], evas_obj_position_set(x + cent, y + ICON_SIZE + 4));
        x += ICON_SIZE + 16;
        if (x > win_w)
          {
             x = 0;
             y += ICON_SIZE + 16;
          }
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}












/* template stuff - ignore */
# endif
#endif

#ifdef UI
_ui_menu_item_add(ICON, NAME, FNAME);
#endif

#ifdef PROTO
void FNAME(void);
#endif

#ifndef PROTO
# ifndef UI
void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
# endif
#endif
#undef FNAME
#undef NAME
#undef ICON
