#undef FNAME
#undef NAME
#undef ICON

/* metadata */
#define FNAME widgets_list_2_start
#define NAME "Widgets List 2"
#define ICON "widgets.png"

#ifndef PROTO
# ifndef UI
#  include "main.h"

/* standard var */
static int done = 0;
/* private data */
#define NUM 512
#define ICON_SIZE 32
static Evas_Object *o_images[NUM];
static Evas_Object *o_texts[NUM];

static const char *labels[] =
{
   "Andrew",
   "Alex",
   "Amanda",
   "Arthur",
   "Astrid",
   "Avery",

   "Beethoven",
   "Billy",
   "Bob",
   "Bundy",

   "Candy",
   "Carsten",

   "Danny",
   "Dennis",
   "Dirk",
   "Doug",

   "Edmond",
   "Erik",

   "Fernando",
   "Frank",
   "Frederick",

   "Gabby",
   "George",
   "Gilroy",
   "Goodrich",
   "Gumby",
};

/* setup */
static void _setup(void)
{
   int i;
   Evas_Object *o;
   for (i = 0; i < NUM; i++)
     {
        o = eo_add(EVAS_IMAGE_CLASS, G_evas);
        o_images[i] = o;
        eo_do(o, evas_obj_image_filled_set(1),
                 evas_obj_image_border_set(2, 2, 2, 2),
                 efl_file_set(build_path("pan.png"), NULL),
                 evas_obj_size_set(win_w, ICON_SIZE),
                 evas_obj_visibility_set(EINA_TRUE));

        o = eo_add(EVAS_TEXT_CLASS, G_evas);
        o_texts[i] = o;
        eo_do(o, efl_text_properties_font_set("Vera-Bold", 10),
                 efl_text_set(labels[i % 26]),
                 evas_obj_color_set(0, 0, 0, 255),
                 evas_obj_visibility_set(EINA_TRUE));
     }
   done = 0;
}

/* cleanup */
static void _cleanup(void)
{
   int i;
   for (i = 0; i < NUM; i++)
     {
        eo_del(o_images[i]);
        eo_del(o_texts[i]);
     }
}

/* loop - do things */
static void _loop(double t, int f)
{
   int i;
   Evas_Coord x, y, tw, th, cent;
   x = 0;
   y = 0 - f;
   for (i = 0; i < NUM; i++)
     {
        eo_do(o_images[i], evas_obj_position_set(x, y));
        eo_do(o_texts[i], evas_obj_size_get(&tw, &th));
        cent = (ICON_SIZE - th) / 2;
        eo_do(o_texts[i], evas_obj_position_set(x + 8, y + cent));
        y += ICON_SIZE;
     }
   FPS_STD(NAME);
}

/* prepend special key handlers if interactive (before STD) */
static void _key(char *key)
{
   KEY_STD;
}












/* template stuff - ignore */
# endif
#endif

#ifdef UI
_ui_menu_item_add(ICON, NAME, FNAME);
#endif

#ifdef PROTO
void FNAME(void);
#endif

#ifndef PROTO
# ifndef UI
void FNAME(void)
{
   ui_func_set(_key, _loop);
   _setup();
}
# endif
#endif
#undef FNAME
#undef NAME
#undef ICON
